#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"hwrap.h"

int	bopen(hwrap_state*, long);
static int	bincrease(hwrap_state*, long);
void	bclose(hwrap_state*);
int	bseek(hwrap_state*, long);
int	bputc(STR, hwrap_state*);
int	bputs(STR*, hwrap_state*);
int	bgetc(long, hwrap_state*);
void	bflush(hwrap_state*, FLAG*);


/* iobt@I[v */
int
bopen(s, size)
hwrap_state	*s;
long	size;
{
	s->bufmax = (size > BUFSIZE)?size:BUFSIZE;
	s->buf = malloc(sizeof(STR) * s->bufmax);
	if (!s->buf) {
		fputs("܂\n", stderr);
		return FALSE;
	}

	s->buf_p = 0;

	return TRUE;
}

/* iobt@g */
static int
bincrease(s, size)
hwrap_state	*s;
long	size;
{
	long	i, newsize;
	STR	*newbuf;

	newsize = (size > s->bufmax)? (s->bufmax + size):(s->bufmax * 2);
	newbuf = malloc(sizeof(STR) * newsize);
	if (!newbuf) {
		fputs("܂\n", stderr);
		return FALSE;
	}

	for (i = 0; i < s->bufmax; i++) {
		newbuf[i] = s->buf[i];
	}
	free (s->buf);
	s->buf = newbuf;
	s->bufmax = newsize;

	return TRUE;
}

/* iobt@|C^ړ */
int
bseek(s, p)
hwrap_state	*s;
long	p;
{
	if (p < 0 || p >= s->bufmax)	return FALSE;
	s->buf_p = p;
	return TRUE;
}

/* iobt@N[Y */
void
bclose(s)
hwrap_state	*s;
{
	free (s->buf);
}

/* iobt@1 */
int
bputc(c, s)
STR	c;
hwrap_state	*s;
{
	if (s->buf_p >= s->bufmax) {
		if (!bincrease(s, s->bufmax))	return FALSE;
	}

	s->buf[s->buf_p++] = c;
	return TRUE;
}

/* iobt@񏑂 */
int
bputs(str, s)
STR	*str;
hwrap_state	*s;
{
	long	len = strlen(str) + 1;
	STR	*p = str;

	if (s->buf_p + len >= s->bufmax) {
		if (!bincrease(s, len))	return FALSE;
	}

	while (*p)	s->buf[s->buf_p++] = *p++;
	*p = '\0';

	return TRUE;
}

/* iobt@1ǂݏo */
int
bgetc(p, s)
long	p;
hwrap_state	*s;
{
	if ((s->buf_p += p) < 0)	return 0;
	if (s->buf_p >= s->size)	return -1;

	return (STR)(s->buf[s->buf_p - 1]);
}

/* iobt@o */
void
bflush(s, type)
hwrap_state	*s;
FLAG	*type;
{
	int	macrotype;

	/* obt@I */
	bputc('\0', s);
	s->size = s->buf_p;
	bseek(s, 0);

	macro_init(s);
	if (!s->buf[0]) {
		if (!s->usepb) {
			putemptyline(s);
			s->usepb = TRUE;
		}
	} else if (*type > 0) {
		s->usepb = FALSE;
		macrotype = macro(s);	/* }N */
		if (!macrotype) {
			print(s);			/* HFILL, BOX ͏o͂Kv */
		} else if (macrotype < 0) {
			*type = 0;
			return;
		}
	} else {
		do {
			wrap(s);
			print(s);
		} while (s->buf_p < s->size);
	}
	bclose(s);
	if (!bopen(s, BUFSIZE * 4))	exit(2);
}
