#include	<stdio.h>
#include	<string.h>

#include	"hwrap.h"

#define	BLKMACRO_MAX	11

static void	nakedprint(hwrap_state*);
static void	putboxedge(hwrap_state*);
static void	indent(hwrap_state*, int);
static int	whatblock(STR*);
int	begin_proc(hwrap_state*s, STR*);
int	end_proc(hwrap_state*s, STR*);


/* VERBATIM o */
static void
nakedprint(s)
hwrap_state	*s;
{
	static STR	endverb[] = "\\END{VERBATIM}";
	STR	*p, *e, c, buf[BUFSIZE];

	while (fgets(buf, BUFSIZE, s->fp)) {
		p = buf;
		e = endverb;
		while (*p == ' ' || *p == '\t')	p++;
		do {
			if (!*e)	return;
			c = *p++;
			if (!symboltbl[c])	c &= 0xdf;
		} while (c == *e++);
		fputs(buf, stdout);
	}
}

/* BOX  Co */
static void	putboxedge(s)
hwrap_state	*s;
{
	int	j;

	s->outct = 0;
	s->outbuf[s->outct++] = '+';
	for (j = 0; j < s->stdcolum - 1; j++) {
		s->outbuf[s->outct++] = '-';
	}
	s->outbuf[s->outct++] = '+';
	s->outbuf[s->outct] = '\0';
}


/*  */
static void
indent(s, i)
hwrap_state	*s;
int	i;
{
	if (i) {
		s->stdcolum += QUOTE_COLUMNS;
		s->indcol -= QUOTE_COLUMNS;
	} else {
		s->stdcolum -= QUOTE_COLUMNS;
		s->indcol += QUOTE_COLUMNS;
	}
}

/* ubN */
static int
whatblock(param)
STR	*param;
{
	int	i;
	static STR	*block[BLKMACRO_MAX] = {
				"TITLE", "CENTER", "RIGHT",
				"BOX",
				"QUOTE", "QUOTATION", "RQUOTE",
				"ITEMIZE", "ENUMERATE", "DESCRIPTION",
				 "VERBATIM"
			};

	for (i = BLKMACRO_MAX; --i >= 0;) {
		if (!strcmpi(param, block[i])) {
			break;
		}
	}
	return i;
}

/* ubNJn}N */
int
begin_proc(s, param)
hwrap_state	*s;
STR	*param;
{
	int	i = whatblock(param);
	int	macrotype = 1;

	if (s->boxon) {
		if (i > 2)	return	1;
	}
	switch(i) {
	case 0:	putemptyline(s);			/* TITLE */

	case 1: /* CENTER */
		if (!s->align)	s->align = 1;
		break;

	case 2:	/* RIGHT */
		if (!s->align)	s->align = -1;
		break;

	case 3:	/* BOX */
		putboxedge(s);
		s->post_bak = s->post;
		s->post = 0;	/* Ԃ炳֑Ȃ */
		s->boxon = 2;
		s->stdcolum -= 2;
		macrotype = 0;
		break;

	case 4:	s->nextline |= 2;			/* QUOTE */
	case 5:	/* QUOTATION */
		if (s->quotetype < 2 && s->q_level < 4
				&& s->stdcolum > QUOTE_COLUMNS * 2+ 2) {
			s->quotetype = 1;
			s->q_level++;
			s->stdcolum -= QUOTE_COLUMNS * 2;
			s->indcol += QUOTE_COLUMNS;
			putemptyline(s);
		}
		break;

	case 6:	/* R_QUOTE */
		if ((s->quotetype == 0 || s->quotetype == 3 )
				&& s->rq_level < 4
				&& s->stdcolum > QUOTE_COLUMNS * 2 + 2) {
			indent(s, 0);

			s->quotetype = 3;
			s->rq_level++;
			putemptyline(s);
		}
		break;

	case 7:	/* ITEMIZE */
		if (s->listlevel < 4) {
			indent(s, 0);
			s->it_level++;
			s->listlevel++;
			s->listtype[s->listlevel] = 1;
		}
		break;

	case 8:	/* ENUMERATE */
		if (s->listlevel < 4) {
			indent(s, 0);
			s->en_level++;
			s->listlevel++;
			s->en_num[s->en_level] = 0;
			s->listtype[s->listlevel] = 2;
		}
		break;

	case 9:	/* DESCRIPTION */
		if (s->listlevel < 4) {
			indent(s, 0);
			s->it_level++;
			s->listlevel++;
			s->listtype[s->listlevel] = 3;
		}
		break;

	case 10:	nakedprint(s);	break;	/* VERBATIM */
	}
	return macrotype;
}

/* ubNI}N */
int
end_proc(s, param)
hwrap_state	*s;
STR	*param;
{
	int	i = whatblock(param);
	int	macrotype = 1;

	if (s->boxon) {
		if (i > 3)	return	1;
	}
	switch(i) {
	case 0: putemptyline(s);			/* TITLE */
	case 1:	/* CENTER  */
			if (s->align > 0)	s->align = 0;
			break;	
	case 2:	/* RIGHT E */
			if (s->align < 0)	s->align = 0;
			break;

		break;

	case 3:	/* BOX */
		s->post = s->post_bak;
		s->stdcolum += 2;
		s->boxon = 0;
		putboxedge(s);
		macrotype = 0;
		break;

	case 4:	s->nextline &= 0xfd;		/* QUOTE */
	case 5:	/* QUOTATION */
		if (s->quotetype == 1 && s->q_level) {
			if (!--s->q_level)	s->quotetype = 0;
			s->stdcolum += QUOTE_COLUMNS * 2;
			s->indcol -= QUOTE_COLUMNS;
			putemptyline(s);
		}
		break;

	case 6:	/* RQUOTE */
		if (s->quotetype == 3 && s->rq_level) {
			indent(s, 1);
			s->rq_level--;
			if (!s->rq_level)	s->quotetype = 0;
			putemptyline(s);
		}
		break;

	case 7:	/* ITEMIZE */
		if (s->listtype[s->listlevel] == 1) {
			indent(s, 1);
			s->it_level--;
			s->listlevel--;
		}
		break;

	case 8:	/* ENUMERATE */
		if (s->listtype[s->listlevel] == 2) {
			indent(s, 1);
			s->en_level--;
			s->listlevel--;
		}
		break;

	case 9:	/* DESCRIPTION */
		if (s->listtype[s->listlevel] == 3) {
			indent(s, 1);
			s->it_level--;
			s->listlevel--;
		}
		break;
	}
	return macrotype;
}
