/*
		hwrap.h

	original 1998 Kazuhisa Minato
	modified 1999 Rick
*/


/*************************************************************************/
/************************** JX^}CYGA ***************************/
/*************************************************************************/

#define	MACRO_SYMBOL	'\\'
#define	COMMENT_SYMBOL	'%'

#define	EM_CHR	'$'
#define	UL_CHR	'_'
#define	IT_CHR	'^'
#define	ESCEM	"\x1b[1m"
#define	ESCUL	"\x1b[4m"
#define	ESCIT	"\x1b[7m"
#define	ESCEND	"\x1b[m"
#define	ESCBREAK	"\x1b[m\n"

#define  QUOTE_COLUMNS   6		/* QUOTE ̎ */
#define  DEFAULT_COLUMNS 70		/* 1šWݒ */

#ifdef USE_EUC
#define	iskanji(c)	(int)((char)c < 0)
#else
#define	iskanji(c)	(int)(symboltbl[c] == -1)
#endif

typedef  unsigned char STR;
typedef  char FLAG;

#ifndef TRUE
#define TRUE	1
#endif
#ifndef FALSE
#define FALSE	0
#endif

#define	BUFSIZE		1024
#define	TAB			0x09
#define	LF			0x0a
#define	CR			0x0d
#define	ESCC		0x1b


typedef struct {
	long	buf_p;			/* iobt@̃|C^ */
	long	buf_bak;		/* |C^ۑl */
	long	size;			/* i̒ */
	long	bufmax;			/* iobt@ő */
	STR	*buf;				/* iobt@ */
	short	outct;			/* 1so̓oCg(|C^) */
	short	outesc;			/* 1soESCoCg */
	short	outasc;			/* pPo̓oCg(outbuf߂p) */
	short	inasc;			/* pP̓oCg(buf߂p) */
	short	stdcolum;		/* ܂Ԃ */
	short	colum;			/* ␳ςݐ܂Ԃ */
	short	colum_bak;		/* ֑Es镶 */
	short	indcol;			/*  */
	short	margin;			/* ] */
	short	iconlen;		/* }[N̒ */
	short	escon;			/* ESCV[PX̍Œۂ */
	long	section;		/* ͐ߔԍ */
	FILE	*fp;			/* ̓Xg[ */
	FLAG	useesc;			/* ESCV[PXgp */
	FLAG	fasc;			/* ȂׂASCIIϊ邩 */
	FLAG	spcdiv;			/* pXy[XP؂ɂ */
	FLAG	post;			/* Ԃ炳֑邩 */
	FLAG	post_bak;		/* g[hɓŐ֑[hۑ */
	FLAG	boxon;			/* g[hۂ */
	FLAG	usepb;			/* A LF  */
	FLAG	backskip;		/* ͂ݏo܂Ƃ߂Ė߂ */

	FLAG	nextline;		/* ̍s̏ */
	FLAG	puticon;		/* }[No͂邩 */
	FLAG	it_level;		/* ITEMIZE x */
	FLAG	en_level;		/* ENUMERATE x */
	FLAG	en_num[4];		/* ENUMERATE ex݂̌̐ */
	FLAG	listtype[5];	/*  1:itemize 2:enumerate */
	FLAG	listlevel;		/* (ITEMIZE + ENUMERATE)x( < 4) */
	FLAG	q_level;		/* x( < 4) */
	FLAG	quotetype;		/*  = 0(nothing):1(quote)
											:2(drow):3(rquote) */
	FLAG	rq_level;		/* rq_level x */
	FLAG	align;			/* o͈ʒu 0(left):1(center):-1(right) */

	STR	esc[6];				/* ESCR[hobt@ */
	STR	outbuf[BUFSIZE];	/* 1so͗pobt@ */
	STR	icon[BUFSIZE];		/* ̃}[N */
} hwrap_state;


/* ֐錾 */

/* hwrap.c */
extern void	wrap(hwrap_state*);
extern void	hwrap(hwrap_state*);

/* macro.c */
extern int	macro(hwrap_state*);

/* block.c */
extern int	begin_proc(hwrap_state*, STR*);
extern int	end_proc(hwrap_state*, STR*);

/* print.c */
extern void	macro_init(hwrap_state*);
extern void	prespc(hwrap_state*, STR*);
extern void	putemptyline(hwrap_state*);
extern void	print(hwrap_state*);

/* bio.c */
extern int	bopen(hwrap_state*, long);
extern void	bclose(hwrap_state*);
extern int	bseek(hwrap_state*, long);
extern int	bputc(STR, hwrap_state*);
extern int	bputs(STR*, hwrap_state*);
extern int	bgetc(long, hwrap_state*);
extern void	bflush(hwrap_state*, FLAG*);

/* codetbl.c */
extern char	puncttbl[];
extern char	alnumtbl[];
extern char	symboltbl[];
