#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"hwrap.h"

#define	MACRO_MAX	19

static STR	roman[27][6] = {
		"i", "ii", "iii", "iv", "v", "vi", "vii", "viii", "ix", "x",
		"xi", "xii", "xiii", "xiv", "xv", "xvi", "xvii", "xviii", "xix", "xx",
		"xxi","xxii", "xxiii", "xxiv", "xxv", "xxvi", "xxvii" };


static int	itemproc(hwrap_state*, STR*);
static void	listprint(STR*, int);
static void	setbool(STR*, STR*);
static int	macro_check(STR*, STR*, STR*);
static void	localprint(hwrap_state*);
int	macro(hwrap_state*);


/*  */
static int
itemproc(s, param)
hwrap_state	*s;
STR	*param;
{
	static STR	it_chr[4][3] = { "", "", "E", "|" };

	s->usepb = FALSE;
	if (!(s->listtype[s->listlevel]))	return FALSE;

	switch (s->listtype[s->listlevel]) {
	case 1:		/* ITEMIZE */
			strcpy(s->icon, it_chr[s->it_level]);
			break;

	case 2: {	/* ENUMERATE */
		STR	itoabuf[8];
		switch (s->en_level) {
		case 0:	/* (1) */
			s->en_num[s->en_level]++;
			s->icon[0] = '(';
			strcpy(s->icon + 1,
					itoa(s->en_num[s->en_level], itoabuf, 10));
			strcat(s->icon, ")");
			break;

		case 1:	/* (a) */
			s->en_num[s->en_level]++;
			s->icon[0] = '(';
			s->icon[1] = 'a' + s->en_num[s->en_level] - 1;
			s->icon[2] = ')';
			s->icon[3] = '\0';
			break;

		case 2:	/* i. */
			s->en_num[s->en_level]++;
			strcpy(s->icon, roman[s->en_num[s->en_level] - 1]);
			strcat(s->icon, ".");
			break;

		case 3:	/* No.1 */
			s->en_num[s->en_level]++;
			strcpy(s->icon, "No.");
			strcat(s->icon,
					itoa(s->en_num[s->en_level] - 1, itoabuf, 10));
			strcat(s->icon, " ");
			break;

		default:
			s->iconlen = 0;
			return FALSE;
		}
	 }
		break;

	case 3:		/* DESCRIPTION */
		strcpy(s->icon, param);
		break;

	default:
		s->iconlen = 0;
		return FALSE;
	}
	s->iconlen = strlen(s->icon);
	return TRUE;
}

/* t@C荞ݏo */
static void
listprint(filename, numprint)
STR	*filename;
int	numprint;
{
	FILE	*fp;
	int	num = 1;
	STR	buf[BUFSIZE], itoabuf[8];

	strcpy(itoabuf, "    : ");
	fp = fopen(filename, "rt");
	if (!fp) {
		fputs("include t@C܂\n", stderr);
		return;
	}

	while (fgets(buf, BUFSIZE, fp)) {
		if (numprint) {
			int	wk = num;
			if (num >= 1000) {
				itoabuf[0] = '0' + (wk / 1000);
				wk %= 1000;
			}
			if (num >= 100) {
				itoabuf[1] = '0' + (wk / 100);
				wk %= 100;
			}
			if (num++ >= 10) {
				itoabuf[2] = '0' + (wk / 10);
				wk %= 10;
			}
			itoabuf[3] = '0' + wk;
			fputs(itoabuf, stdout);
		}
		fputs(buf, stdout);
	}

	fclose(fp);
}

static void
setbool(str, result)
STR	*str;
STR	*result;
{
	if (!strcmpi(str, "ON")) {
		*result = TRUE;
	} else if (!strcmpi(str, "OFF")) {
		*result = FALSE;
	}
}

/* }NAo */
static int
macro_check(macro, str, param)
STR	*macro;
STR	*str;
STR	*param;
{
	STR	*r = str + 1,
		*w = macro;

	while (*r) {
		if (!*w || *w != (*r & 0xdf))	break;
		w++;
		r++;
	}

	if (!*w) {				/* v */
		w = param;
		if (*r == '\t') {	/* p[^擾 */
			r++;
			while (*r && *r != '\t') {
				if (iskanji(*r))	*w++ = *r++;
				*w++ = *r++;
			}
			if (*r)	r++;
		}
		*w = '\0';
		strcpy(str, r);		/* vf擾 */
		return TRUE;
	} else {
		return FALSE;
	}
}

/* ܂Ԃďo */
static void
localprint(s)
hwrap_state	*s;
{
	do {
		wrap(s);
		print(s);
	} while (s->buf_p < s->size);
}

/* }N */
int
macro(s)
hwrap_state	*s;
{
	int	i;
	static STR	*macro[MACRO_MAX] = {
				"LENGTH", "NARROW", "MARGIN",
				"KINSOKU",
				"INCLUDE", "LIST",
				"ASCCNV", "USEESC", "SPACEDIV",
				"PART", "SECTION", "SUBSECTION", "PARAGRAPH",
				"HFILL", "VSPACE", "NOINDENT",
				"BEGIN", "END",
				"ITEM"
	};
	FLAG	macrotype = 2;
	STR	param[BUFSIZE], itoabuf[8];

/*	Ucase(strcpy(str, s->outbuf));
	if (!strncmp(str + 2, "ESC_PAGEEND", 11)) {
		fputc(0x0C, stdout);
		continue;
	}*/

	for (i = MACRO_MAX; --i >= 0;) {
		if (macro_check(macro[i], s->buf, param)) {
			macrotype = 1;
			break;
		}
	}
	/* {bNXł̃}N */
	if (s->boxon && i < 6)	return 1;

	switch (i) {
	case 0:		/* LENGTH */
		s->stdcolum = atoi(param);
		break;

	case 1:		/* NARROW */
		if (!strcmpi(param, "OFF") && s->quotetype == 2) {
			s->stdcolum += s->indcol * 2;
			s->indcol = 0;
			s->quotetype = 0;
			break;
		}
		if (!s->quotetype || s->quotetype == 2) {
			if (s->stdcolum - s->indcol * 2 < 1)	break;
			s->stdcolum += s->indcol * 2;
			s->indcol = atoi(param);
			s->stdcolum -= s->indcol * 2;
			s->quotetype = 2;
		}
		break;

	case 2:	s->margin = atoi(param);	break;	/* MARGIN ] */
	case 3:	s->post = atoi(param);		break;	/* KINSOKU */
	case 4:	listprint(param, FALSE);	break;	/* INCLUDE t@C荞 */
	case 5:	listprint(param, TRUE);		break;	/* LIST sԍtt@C荞 */
	case 6:	setbool(param, &(s->fasc));		break;	/* ASCCNV */
	case 7:	setbool(param, &(s->useesc));	break;	/* USEESC */
	case 8:	setbool(param, &(s->spcdiv));	break;	/* SPACEDIV */

	case 9: {	/* PART ... DSHELLp؂t & Z^O */
		FLAG	align_bak = s->align;
		STR	*r, *w;

		s->align = 1;
		putemptyline(s);
		putemptyline(s);
		strcpy(s->outbuf, "Part ");
		w = s->outbuf + 5;
		r = roman[s->section >> 24];
		s->section += 0x01000000;
		while (*r) {
			*w++ = *r++ & 0xdf;
		}
		*w = '\0';
		s->outct = w - s->outbuf;
		print(s);
		putemptyline(s);
		strcpy(s->buf, param);
		s->size = strlen(s->buf) + 1;
		localprint(s);
		putemptyline(s);
		putemptyline(s);
		s->align = align_bak;
		break;
	 }
	case 10:		/* SECTION */
		putemptyline(s);
		s->section += 0x00010000;
		s->section &= 0xffff0000;
		itoa((s->section >> 16) & 0xff, s->buf, 10);
		strcat(s->buf,  " ");
		strcat(s->buf, param);
		s->size = strlen(s->buf) + 1;
		localprint(s);
		putemptyline(s);
		break;

	case 11:		/* SUBSECTION */
		putemptyline(s);
		s->section += 0x00000100;
		s->section &= 0xffffff00;
		itoa((s->section >> 16) & 0xff, s->buf, 10);
		itoabuf[0] =  '.';
		itoa((s->section >> 8) & 0xff, itoabuf + 1, 10);
		strcat(s->buf, itoabuf);
		strcat(s->buf,  " ");
		strcat(s->buf, param);
		s->size = strlen(s->buf) + 1;
		localprint(s);
		putemptyline(s);
		break;

	case 12:		/* PARAGRAPH */
		putemptyline(s);
		strcpy(s->buf, param);
		strcat(s->buf, "  ");
		bseek(s, strlen(s->buf));
		macrotype = -1;
		break;

	case 13: {	/* HFILL */
		int	i = 0, j;

		s->outct = 0;
		s->outesc = 0;
		for (j = 0; j <= s->stdcolum;) {
			if (iskanji(param[i])) {
				if (j >= s->stdcolum)	break;
#ifdef USE_EUC
				if (param[i] == 0x8e) {
					/* pJi */
#else
				if ((param[i] == 0x80) || (param[i] >= 0xF0)) {
					/* 2oCgp,1/4pR[h */
#endif
					j++;
				} else {
					j+= 2;
				}
				s->outbuf[s->outct++] = param[i++];
				s->outbuf[s->outct++] = param[i++];
			} else if (param[i] == ESCC) {
				STR	c;
				do {
					if (!(c = param[i++]))	break;
				} while (c != 'm' && c != 'M');
			} else {
				j++;
				s->outbuf[s->outct++] = param[i++];
			}
			if (i >= strlen(param))	i = 0;
		}
		s->outbuf[s->outct] = '\0';
		macrotype = 0;
		break;
	 }
	case 14: {	/* VSPACE */
		int	j = atoi(param);
		while (--j >= 0)	putemptyline(s);
		break;
	}
	case 15:	s->nextline |= 1;	break;	/* NOINDENT */
	case 16:	macrotype = begin_proc(s, param);	break;
	case 17:	macrotype = end_proc(s, param);		break;

	case 18:	/* ITEM */
		if (itemproc(s, param))	{
			bseek(s, strlen(s->buf));
			macrotype = -1;
		}
		break;
	} /* end_switch */

	return macrotype;
}
